import java.util.*;

public class Customer {
	private Euro totalCharge = new Euro(0.00);

	private List rentals = new ArrayList();

	public void rentMovie(Movie movie, int daysRented) {
		totalCharge = totalCharge.plus(movie.getCharge(daysRented));
		rentals.add(new Rental(movie, daysRented));
	}

	public String printStatement() {
		return printStatementDetail() + printStatementFooter();
	}

	public void printStatementDetail(IPrinter printer)
			throws PrinterException {
		try {
			for (Iterator i = rentals.iterator(); i.hasNext();) {
				Rental rental = (Rental) i.next();
				printer.tab();
				printer.print(rental.getMovieTitle());
				printer.tab();
				printer.print(rental.getCharge().format());
				printer.crlf();
			}
			printer.cutPaper();
		} catch (OutOfPaperException e) {
			throw new PrinterException();
		}
	}

	public String printStatementDetail() {
		String result = "";
		for (Iterator i = rentals.iterator(); i.hasNext();) {
			Rental rental = (Rental) i.next();
			result += "\t" + rental.getMovieTitle() + "\t"
					+ rental.getCharge().format() + "\n";
		}
		return result;
	}

	public String printStatementFooter() {
		return "Gesamt: " + getTotalCharge().format() + "\n";
	}

	public Euro getTotalCharge() {
		Euro result = new Euro(0);
		for (Iterator i = rentals.iterator(); i.hasNext();) {
			Rental rental = (Rental) i.next();
			result = result.plus(rental.getCharge());
		}
		return result;
	}
}