import org.easymock.MockControl;

public class MovieTest extends junit.framework.TestCase {
	public void testSettingNewPrice() {
		Movie movie = new Movie("Brazil", Price.NEWRELEASE);
		movie.setPrice(Price.REGULAR);
		assertEquals(new Euro(1.50), movie.getCharge(3));
	}

	public void testWithStubPrice() {
		MockControl control = MockControl.createControl(IPrice.class); 
		IPrice stubPrice = (IPrice) control.getMock(); 
		stubPrice.getCharge(3); 
		control.setReturnValue(new Euro(2.00)); 
		
		control.replay();

		Movie movie = new Movie("Matrix", stubPrice);
		assertEquals(new Euro(2.00), movie.getCharge(3));
	}
}