import junit.framework.AssertionFailedError;
import junit.framework.TestCase;

public class SimpleExpectationValueTest extends TestCase {
	private SimpleExpectationValue value;

	protected void setUp() {
		value = new SimpleExpectationValue("expectation value");
	}

	public void testExpectedValue() {
		value.setExpected("Night on Earth");
		value.setActual("Night on Earth");
		value.verify();
	}

	public void testWrongValue() {
		value.setExpected("Stranger than Paradise");
		try {
			value.setActual("Down by Law");
		} catch (AssertionFailedError expected) {
			return;
		}
		fail("Should have detected a failed expectation");
	}

	public void testNoValue() {
		value.setExpected("Dead Man");
		try {
			value.verify();
		} catch (AssertionFailedError expected) {
			return;
		}
		fail("Should have detected a missed expectation");
	}
}
